(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('reflect-metadata'), require('rxjs'), require('@angular/common/http')) :
    typeof define === 'function' && define.amd ? define('ddd-form', ['exports', '@angular/core', '@angular/common', '@angular/forms', 'reflect-metadata', 'rxjs', '@angular/common/http'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["ddd-form"] = {}, global.ng.core, global.ng.common, global.ng.forms, null, global.rxjs, global.ng.common.http));
})(this, (function (exports, i0, i2$1, i2, reflectMetadata, rxjs, i1) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i2__namespace = /*#__PURE__*/_interopNamespace(i2$1);
    var i2__namespace$1 = /*#__PURE__*/_interopNamespace(i2);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);

    var DynamicFormContextService = /** @class */ (function () {
        function DynamicFormContextService() {
        }
        DynamicFormContextService.prototype.setContext = function (ctx) {
            this.context = ctx;
        };
        DynamicFormContextService.prototype.getContext = function () {
            return this.context;
        };
        return DynamicFormContextService;
    }());
    DynamicFormContextService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: DynamicFormContextService, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    DynamicFormContextService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: DynamicFormContextService });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: DynamicFormContextService, decorators: [{
                type: i0.Injectable
            }], ctorParameters: function () { return []; } });

    var ButtonTemplateDirective = /** @class */ (function () {
        function ButtonTemplateDirective(templateRef) {
            this.templateRef = templateRef;
        }
        ButtonTemplateDirective.prototype.getTemplate = function () {
            return this.templateRef;
        };
        return ButtonTemplateDirective;
    }());
    ButtonTemplateDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: ButtonTemplateDirective, deps: [{ token: i0__namespace.TemplateRef }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    ButtonTemplateDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: ButtonTemplateDirective, selector: "[dfButton]", ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: ButtonTemplateDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[dfButton]',
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.TemplateRef }]; } });

    var InputTemplateDirective = /** @class */ (function () {
        function InputTemplateDirective(templateRef) {
            this.templateRef = templateRef;
        }
        InputTemplateDirective.prototype.getInputType = function () {
            return this.inputType.toUpperCase();
        };
        InputTemplateDirective.prototype.getTemplateRef = function () {
            return this.templateRef;
        };
        return InputTemplateDirective;
    }());
    InputTemplateDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: InputTemplateDirective, deps: [{ token: i0__namespace.TemplateRef }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    InputTemplateDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: InputTemplateDirective, selector: "[dfInputTemplate]", inputs: { inputType: "inputType" }, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: InputTemplateDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[dfInputTemplate]',
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.TemplateRef }]; }, propDecorators: { inputType: [{
                    type: i0.Input,
                    args: ['inputType']
                }] } });

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var ObjectUtil = /** @class */ (function () {
        function ObjectUtil() {
        }
        /**
         *Patches an object with some value
         *
         * @param {Object} obj
         * @param {Object} patch new state of some attributes
         * @returns {Object}
         */
        ObjectUtil.patchObject = function (obj, patch) {
            var state = {};
            Object.entries(obj).forEach(function (_a) {
                var _b = __read(_a, 2), key = _b[0], value = _b[1];
                if (obj[key] instanceof Object &&
                    !(obj[key] instanceof Date) &&
                    !Array.isArray(obj[key]) &&
                    !(obj[key] instanceof Function)) {
                    if (patch[key]) {
                        state[key] = ObjectUtil.patchObject(obj[key], patch[key]);
                    }
                    else {
                        state[key] = obj[key];
                    }
                }
                else if (Array.isArray(obj[key])) {
                    state[key] = patch[key] || obj[key];
                }
                else {
                    state[key] = patch[key] || obj[key];
                }
            });
            return state;
        };
        return ObjectUtil;
    }());

    exports.InputTypes = void 0;
    (function (InputTypes) {
        InputTypes["COMPOSITE"] = "COMPOSITE";
        InputTypes["TEXT"] = "TEXT";
        InputTypes["NUMBER"] = "NUMBER";
        InputTypes["DATE"] = "DATE";
        InputTypes["SELECT"] = "SELECT";
        InputTypes["CHECKBOX"] = "CHECKBOX";
        InputTypes["RADIO_BUTTONS"] = "RADIO_BUTTONS";
    })(exports.InputTypes || (exports.InputTypes = {}));

    exports.UpdateStrategy = void 0;
    (function (UpdateStrategy) {
        UpdateStrategy["ON_CHANGE"] = "ON_CHANGE";
        UpdateStrategy["ON_PLUR"] = "ON_PLUR";
        UpdateStrategy["ON_SUBMIT"] = "ON_SUBMIT";
    })(exports.UpdateStrategy || (exports.UpdateStrategy = {}));

    var InputNodeImpl = /** @class */ (function () {
        /**
         *
         */
        function InputNodeImpl(properties, control, errorMap) {
            this.childNodes = null;
            this.control = control;
            this.properties = properties;
            this.errorMap = errorMap;
        }
        InputNodeImpl.prototype.setProperties = function (map) {
            this.properties = map;
        };
        InputNodeImpl.prototype.addProperty = function (key, value) {
            this.properties.set(key, value);
        };
        InputNodeImpl.prototype.getProperty = function (key) {
            return this.properties.get(key);
        };
        InputNodeImpl.prototype.setControl = function (control) {
            this.control = control;
        };
        InputNodeImpl.prototype.getControl = function () {
            return this.control;
        };
        InputNodeImpl.prototype.setErrorMap = function (map) {
            this.errorMap = map;
        };
        InputNodeImpl.prototype.getError = function (key) {
            return this.errorMap.get(key);
        };
        InputNodeImpl.prototype.addError = function (key, value) {
            this.errorMap.set(key, value);
        };
        InputNodeImpl.prototype.addChild = function (node) {
            if (this.childNodes != null) {
                this.childNodes.push(node);
            }
            else {
                this.childNodes = [node];
            }
        };
        InputNodeImpl.prototype.addChildren = function (nodes) {
            var _a;
            if (this.childNodes != null) {
                (_a = this.childNodes).push.apply(_a, __spreadArray([], __read(nodes)));
            }
            else {
                this.childNodes = __spreadArray([], __read(nodes));
            }
        };
        InputNodeImpl.prototype.getChildren = function () {
            return this.childNodes;
        };
        InputNodeImpl.prototype.hasChildren = function () {
            return this.childNodes ? true : false;
        };
        // enable
        // disable
        InputNodeImpl.prototype.isValid = function () {
            return this.control.valid;
        };
        InputNodeImpl.prototype.inValid = function () {
            return this.control.invalid;
        };
        InputNodeImpl.prototype.isPending = function () {
            return this.control.pending;
        };
        return InputNodeImpl;
    }());

    var INPUTS_METADATA_KEY = Symbol('InputsMetaData');
    var InputsMetaData = /** @class */ (function () {
        function InputsMetaData() {
        }
        InputsMetaData.add = function (properties, target, propertyKey) {
            Reflect.defineMetadata(INPUTS_METADATA_KEY, InputsMetaData.propertiesToMap(properties), target, propertyKey);
        };
        InputsMetaData.get = function (target, propertyKey) {
            return new Map(Reflect.getMetadata(INPUTS_METADATA_KEY, target, propertyKey));
        };
        InputsMetaData.propertiesToMap = function (properties) {
            var propertiesMap = new Map();
            Object.entries(properties).forEach(function (entry) {
                propertiesMap.set(entry[0], entry[1]);
            });
            return propertiesMap;
        };
        return InputsMetaData;
    }());

    var MapUtil = /** @class */ (function () {
        function MapUtil() {
        }
        MapUtil.formObject = function (obj) {
            var map = new Map();
            Object.entries(obj).forEach(function (keyValue) {
                map.set(keyValue[0], keyValue[1]);
            });
            return map;
        };
        return MapUtil;
    }());

    var FormMeta = /** @class */ (function () {
        function FormMeta(formSpec) {
            this.name = formSpec === null || formSpec === void 0 ? void 0 : formSpec.name;
            this.actions = [];
            this.updateStrategy = formSpec.updateStrategy
                ? formSpec.updateStrategy
                : exports.UpdateStrategy.ON_CHANGE;
        }
        return FormMeta;
    }());

    var FORM_METADATA_KEY = Symbol('FormSpec');
    var FormMetaData = /** @class */ (function () {
        function FormMetaData() {
        }
        FormMetaData.add = function (formSpec, constructor) {
            Reflect.defineMetadata(FORM_METADATA_KEY, MapUtil.formObject(new FormMeta(formSpec)), constructor.prototype);
        };
        FormMetaData.get = function (target) {
            // console.log(target);
            // return Reflect.getMetadata(FORM_METADATA_KEY, target) as Map<string, any>;
            return new Map(Reflect.getMetadata(FORM_METADATA_KEY, target));
        };
        return FormMetaData;
    }());

    var ACTION_METADATA_KEY = Symbol('actions');
    var ActionsMetaData = /** @class */ (function () {
        function ActionsMetaData() {
        }
        ActionsMetaData.add = function (meta, constructor) {
            var actions = ActionsMetaData.get(constructor.prototype);
            if (actions) {
                actions.push(meta);
            }
            else {
                Reflect.defineMetadata(ACTION_METADATA_KEY, [meta], constructor.prototype);
            }
        };
        ActionsMetaData.get = function (target) {
            return Reflect.getMetadata(ACTION_METADATA_KEY, target);
        };
        return ActionsMetaData;
    }());

    var CROSS_VALIDATION_METADATA_KEY = Symbol('CrossValidation');
    var CrossValidationMeta = /** @class */ (function () {
        function CrossValidationMeta() {
        }
        CrossValidationMeta.add = function (spec, constructor) {
            var crossValidationMeta = Reflect.getMetadata(CROSS_VALIDATION_METADATA_KEY, constructor.prototype);
            if (!crossValidationMeta) {
                return Reflect.defineMetadata(CROSS_VALIDATION_METADATA_KEY, [spec], constructor.prototype);
            }
            else {
                crossValidationMeta.push(spec);
            }
        };
        CrossValidationMeta.get = function (target) {
            return Reflect.getMetadata(CROSS_VALIDATION_METADATA_KEY, target);
        };
        return CrossValidationMeta;
    }());

    var ID_META_KEY = Symbol('Id');
    var ON_CONTEXT_META_KEY = Symbol('ON_CONTEXT_META_KEY');
    var USE_CONTEXT_META_KEY = Symbol('USE_CONTEXT_META');
    /**
     * used to override some attributes in some context
     * a filed may be disabled in a context and enabled in another
     * or may have different style and so on ..
     *
     * @param specs {context: string;
      properties: OverridableProperties;}
     * @returns none
     */
    function ContextOverride(specs) {
        return function (target, propertyKey) {
            Reflect.defineMetadata(ON_CONTEXT_META_KEY, specs, target, propertyKey);
        };
    }
    function Id() {
        return function (target, propertyKey) {
            // console.log('target id', target);
            Reflect.defineMetadata(ID_META_KEY, propertyKey, target);
        };
    }
    /**
     * used to bind field existence with context variable
     * the field will only appear if its context equals form context
     * if no context is specified to field it appears in all contexts
     *
     * @param ctx string
     * @returns none
     */
    function UseContext(ctx) {
        return function (target, propertyKey) {
            Reflect.defineMetadata(USE_CONTEXT_META_KEY, ctx, target, propertyKey);
        };
    }

    var ASYNC_VALIDATION_METADATA_KEY = Symbol('AsyncValidationSpec');
    var AsyncValidationMeta = /** @class */ (function () {
        function AsyncValidationMeta() {
        }
        AsyncValidationMeta.add = function (validationSpec, target, propertyKey) {
            var validationMeta = Reflect.getMetadata(ASYNC_VALIDATION_METADATA_KEY, target, propertyKey);
            if (validationMeta) {
                validationMeta.push(validationSpec);
            }
            else {
                Reflect.defineMetadata(ASYNC_VALIDATION_METADATA_KEY, [validationSpec], target, propertyKey);
            }
        };
        AsyncValidationMeta.get = function (target, propertyKey) {
            return Reflect.getMetadata(ASYNC_VALIDATION_METADATA_KEY, target, propertyKey);
        };
        AsyncValidationMeta.getValidatorsAndErrorMap = function (target, propertyKey) {
            // return Reflect.getMetadata(VALIDATION_METADATA_KEY, target, propertyKey) as ValidationSpec[] | undefined
            var validatorsAndErrorMap = {
                validators: new Array(),
                errorMap: new Map(),
            };
            var validationSpecs = AsyncValidationMeta.get(target, propertyKey);
            if (validationSpecs) {
                validationSpecs.forEach(function (spec) {
                    validatorsAndErrorMap.validators.push(spec.validator);
                    validatorsAndErrorMap.errorMap.set(spec.errorName, spec.errorMessage);
                });
            }
            return validatorsAndErrorMap;
        };
        return AsyncValidationMeta;
    }());

    var VALIDATION_METADATA_KEY = Symbol('ValidationSpec');
    var ValidationsMetaData = /** @class */ (function () {
        function ValidationsMetaData() {
        }
        ValidationsMetaData.add = function (validationSpec, target, propertyKey) {
            var validationMeta = Reflect.getMetadata(VALIDATION_METADATA_KEY, target, propertyKey);
            if (validationMeta) {
                validationMeta.push(validationSpec);
            }
            else {
                Reflect.defineMetadata(VALIDATION_METADATA_KEY, [validationSpec], target, propertyKey);
            }
        };
        ValidationsMetaData.get = function (target, propertyKey) {
            return Reflect.getMetadata(VALIDATION_METADATA_KEY, target, propertyKey);
        };
        ValidationsMetaData.getValidatorsAndErrorMap = function (target, propertyKey) {
            // return Reflect.getMetadata(VALIDATION_METADATA_KEY, target, propertyKey) as ValidationSpec[] | undefined
            var validatorsAndErrorMap = {
                validators: new Array(),
                errorMap: new Map(),
            };
            var validationSpecs = ValidationsMetaData.get(target, propertyKey);
            if (validationSpecs) {
                validationSpecs.forEach(function (spec) {
                    validatorsAndErrorMap.validators.push(spec.validatorFn);
                    validatorsAndErrorMap.errorMap.set(spec.errorName, spec.errorMessage);
                });
            }
            return validatorsAndErrorMap;
        };
        return ValidationsMetaData;
    }());

    var InputProcessorService = /** @class */ (function () {
        function InputProcessorService(injector) {
            this.injector = injector;
        }
        InputProcessorService.prototype.process = function (entity, context, key) {
            var properties = InputsMetaData.get(entity, key) || new Map();
            var formControl = new i2.FormControl(entity[key] //initialize
            );
            var errorMap = new Map();
            this.handleOnContextOverrideAndProcessProperties(entity, context, key, properties, errorMap, formControl);
            this.handleValidation(entity, context, key, properties, errorMap, formControl);
            this.handleAsyncValidation(entity, context, key, properties, errorMap, formControl);
            var inputNode = new InputNodeImpl(properties, formControl, errorMap);
            return inputNode;
        };
        /**
         *
         * @param entity
         * @param context
         * @param key
         * @param properties
         */
        InputProcessorService.prototype.handleOnContextOverrideAndProcessProperties = function (entity, context, key, properties, errorMap, control) {
            var contextSpecs = Reflect.getMetadata(ON_CONTEXT_META_KEY, entity, key);
            // console.log("ctx-specs", contextSpecs);
            if (contextSpecs && contextSpecs.context == context) {
                Object.entries(contextSpecs.properties).forEach(function (_a) {
                    var _b = __read(_a, 2), k = _b[0], v = _b[1];
                    properties.set(k, v);
                });
            }
            if (properties.has('disabled') && properties.get('disabled') == true) {
                control.disable({ emitEvent: false });
            }
        };
        /**
         *
         * @param entity
         * @param context
         * @param key
         * @param properties
         * @param errorMap
         * @param control
         */
        InputProcessorService.prototype.handleValidation = function (entity, context, key, properties, errorMap, control) {
            var e_1, _a;
            var res = ValidationsMetaData.getValidatorsAndErrorMap(entity, key);
            // console.log('res', res);
            if (res.validators.includes(i2.Validators.required)) {
                properties.set('required', true); // if required set required attribute
            }
            try {
                for (var _b = __values(res.errorMap.entries()), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var entry = _c.value;
                    // console.log('entry',entry[0], entry[1]);
                    errorMap.set(entry[0], entry[1]);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            control.addValidators(res.validators);
        };
        /**
         *
         * @param entity
         * @param key
         * @param formControl
         * @param errorMap
         */
        InputProcessorService.prototype.handleAsyncValidation = function (entity, context, key, properties, errorMap, formControl) {
            var _this = this;
            // async validation
            var asyncValAndError = AsyncValidationMeta.getValidatorsAndErrorMap(entity, key);
            // console.log(asyncValAndError);
            asyncValAndError.validators.forEach(function (asyncVal) {
                // console.log(asyncVal);
                if (asyncVal === null || asyncVal === void 0 ? void 0 : asyncVal.provider) {
                    var injValidator = _this.injector.get(asyncVal === null || asyncVal === void 0 ? void 0 : asyncVal.provider);
                    // console.log('async validation processing', injValidator);
                    formControl.addAsyncValidators(injValidator.validate);
                    // formControl.updateValueAndValidity();
                }
                else if (asyncVal.validate) {
                    formControl.addAsyncValidators(asyncVal.validate);
                }
                else if (typeof asyncVal == 'function') {
                    formControl.addAsyncValidators(asyncVal);
                }
            });
            asyncValAndError.errorMap.forEach(function (value, key) {
                errorMap.set(key, value);
            });
        };
        return InputProcessorService;
    }());
    InputProcessorService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: InputProcessorService, deps: [{ token: i0__namespace.Injector }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    InputProcessorService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: InputProcessorService });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: InputProcessorService, decorators: [{
                type: i0.Injectable
            }], ctorParameters: function () { return [{ type: i0__namespace.Injector }]; } });

    var FormEntityProcessorService = /** @class */ (function () {
        function FormEntityProcessorService(inputProcessor) {
            this.inputProcessor = inputProcessor;
        }
        /**
         *Builds tree like structure from form entities
         *
         * @param formEntity class annotated with `FormEntity`
         * @param context `string` for proper usage please go to docs
         * @returns `InputNode` tree of input nodes
         */
        FormEntityProcessorService.prototype.process = function (formEntity, context) {
            var root = this.parse(formEntity, context || '');
            this.processEnableFn(root); // this.handleEnableFn(node, (node.getControl() as FormGroup).getRawValue()); // should nt be here
            this.processOrder(root);
            return root;
        };
        /**
         * Used internally to build input nodes
         *
         * @param entity class annotated with `FormEntity`
         * @param context `string` for proper usage please go to docs
         * @param parentProperties `Map<string, any>`
         * @returns `InputNode`
         */
        FormEntityProcessorService.prototype.parse = function (entity, context, parentProperties) {
            var _this = this;
            // handling actions meta data
            var formProperties = parentProperties || FormMetaData.get(entity);
            var actions = ActionsMetaData.get(entity);
            if (formProperties) {
                formProperties.set('actions', actions);
            }
            var childInputs = [];
            this.processUseContext(entity, context).forEach(function (key) {
                if (_this.isNotComposite(entity, key)) {
                    var inputNode = _this.inputProcessor.process(entity, context, key);
                    childInputs.push(inputNode);
                }
                else if (_this.isComposite(entity, key)) {
                    var nestedFormNode = _this.processNestedForm(entity, context, key, formProperties);
                    childInputs.push(nestedFormNode);
                }
                else {
                    // some fields have no meta data they must not be processed
                }
            });
            var fomGroupInitializer = {};
            childInputs.forEach(function (inputNode) {
                fomGroupInitializer[inputNode.getProperty('name')] =
                    inputNode.getControl();
            });
            var formNode = new InputNodeImpl(formProperties, new i2.FormGroup(fomGroupInitializer, {
                updateOn: this.processUpdateStrategy(formProperties),
            }), new Map());
            formNode.addChildren(childInputs);
            this.processCrossValidation(entity, formNode);
            return formNode;
        };
        /**
         *Returns attributes within given context
         *
         * @param entity
         * @param context
         * @returns `string[]` attributes within context
         */
        FormEntityProcessorService.prototype.processUseContext = function (entity, context) {
            var inContextAttrs = [];
            for (var key in entity) {
                var ctx = Reflect.getMetadata(USE_CONTEXT_META_KEY, entity, key);
                if (ctx && context && context != ctx) {
                    // console.log('ctx ', ctx, 'context ', context);
                    continue;
                }
                else {
                    inContextAttrs.push(key);
                }
            }
            return inContextAttrs;
        };
        /**
         * Used internally to prepare nested form entity and its properties
         * to be used with `createNode`
         *
         * @param entity class with `@FormEntity`
         * @param context `string`
         * @param key `string`
         * @param formProperties parent form properties `Map<string, any>` current impl overrides nested form properties with its parent this may change in the future
         * @returns `InputNode` tree like that holds nodes
         */
        FormEntityProcessorService.prototype.processNestedForm = function (entity, context, key, formProperties) {
            var e_1, _d, e_2, _e;
            var properties = InputsMetaData.get(entity, key);
            var nestedFormEntity = new (properties.get('declaredClass'))();
            // initialize nested form entity values
            if (entity[key] != null) {
                Object.keys(entity[key]).forEach(function (k) {
                    nestedFormEntity[k] = entity[key][k];
                });
            }
            var nestedFormNode = this.parse(nestedFormEntity, context, new Map(formProperties));
            try {
                // fill node properties with nested form properties
                for (var _f = __values(properties.entries()), _g = _f.next(); !_g.done; _g = _f.next()) {
                    var propertyKeyValue = _g.value;
                    nestedFormNode.addProperty(propertyKeyValue[0], propertyKeyValue[1]);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_g && !_g.done && (_d = _f.return)) _d.call(_f);
                }
                finally { if (e_1) throw e_1.error; }
            }
            try {
                // override nested form properties with its parent properties
                // warn??
                for (var _h = __values(formProperties.entries()), _j = _h.next(); !_j.done; _j = _h.next()) {
                    var propertyKeyValue = _j.value;
                    if (propertyKeyValue[0] != 'name' && propertyKeyValue[0] != 'action') {
                        nestedFormNode.addProperty(propertyKeyValue[0], propertyKeyValue[1]);
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_j && !_j.done && (_e = _h.return)) _e.call(_h);
                }
                finally { if (e_2) throw e_2.error; }
            }
            return nestedFormNode;
        };
        /**
         * Return qupdate strategy form mrta data if not set default `change`
         *
         * @param formProperties
         * @returns
         */
        FormEntityProcessorService.prototype.processUpdateStrategy = function (formProperties) {
            // update strategy
            var updateOn;
            switch (formProperties.get('updateStrategy')) {
                case exports.UpdateStrategy.ON_PLUR:
                    updateOn = 'blur';
                    break;
                case exports.UpdateStrategy.ON_SUBMIT:
                    updateOn = 'submit';
                    break;
                default:
                    updateOn = 'change';
                    break;
            }
            return updateOn;
        };
        /**
         * Applies cross validation to form
         * @param entity
         * @param formNode
         */
        FormEntityProcessorService.prototype.processCrossValidation = function (entity, formNode) {
            var crossValidators = CrossValidationMeta.get(entity);
            if (crossValidators && crossValidators.length > 0) {
                crossValidators.forEach(function (cv) {
                    formNode.getControl().addValidators([cv.validatorFn]);
                    formNode.getControl().updateValueAndValidity();
                });
            }
            crossValidators === null || crossValidators === void 0 ? void 0 : crossValidators.forEach(function (validator) {
                validator.effects.forEach(function (effect) {
                    var _a;
                    var relatedInput = (_a = formNode
                        .getChildren()) === null || _a === void 0 ? void 0 : _a.find(function (i) { return i.getProperty('name') == effect.input; });
                    relatedInput === null || relatedInput === void 0 ? void 0 : relatedInput.addError(validator.errorName, effect.message);
                });
            });
        };
        /**
         * Handles `enableFn` meta attribute
         * @param root `InputNode`
         */
        FormEntityProcessorService.prototype.processEnableFn = function (root) {
            var _this = this;
            root === null || root === void 0 ? void 0 : root.getControl().valueChanges.subscribe(function (formValue) {
                var _a;
                (_a = root.getChildren()) === null || _a === void 0 ? void 0 : _a.forEach(function (node) {
                    _this.applyIfDefined(node, formValue);
                });
            });
        };
        /**
         * Used to apply `enableFn` after setting from value manually and silent change events
         * so keep it consistent
         *
         * @param root `InputNode`
         */
        FormEntityProcessorService.prototype.applyEnableFn = function (root) {
            var _this = this;
            var _a;
            (_a = root.getChildren()) === null || _a === void 0 ? void 0 : _a.forEach(function (node) {
                _this.applyIfDefined(node, root.getControl().getRawValue());
            });
        };
        /**
         * Checks each field recursively to enable or disable it
         * if `enableFn` is defined on it
         *
         * @param root `InputNode`
         * @param formValue `Object`
         */
        FormEntityProcessorService.prototype.applyIfDefined = function (node, formValue) {
            var _this = this;
            var _a, _b, _c;
            if (!node.hasChildren()) {
                if (node.getProperty('enableFn')) {
                    switch (node.getProperty('enableFn')(formValue)) {
                        case true:
                            (_a = node.getControl()) === null || _a === void 0 ? void 0 : _a.enable({ emitEvent: false });
                            break;
                        case false:
                            (_b = node.getControl()) === null || _b === void 0 ? void 0 : _b.disable({ emitEvent: false });
                            break;
                    }
                }
            }
            else {
                (_c = node.getChildren()) === null || _c === void 0 ? void 0 : _c.forEach(function (child) {
                    _this.applyIfDefined(child, formValue[node.getProperty('name')]);
                });
            }
        };
        /**
         * Sorts inputs ASC based on `order` `property`
         * @param inputNode `InputNode`
         *
         */
        FormEntityProcessorService.prototype.processOrder = function (inputNode) {
            var _this = this;
            var _a, _b;
            if (!inputNode.hasChildren()) {
                return;
            }
            else {
                (_a = inputNode
                    .getChildren()) === null || _a === void 0 ? void 0 : _a.sort(function (a, b) { return a.getProperty('order') - b.getProperty('order'); });
                (_b = inputNode.getChildren()) === null || _b === void 0 ? void 0 : _b.forEach(function (child) { return _this.processOrder(child); });
            }
        };
        FormEntityProcessorService.prototype.isNotComposite = function (entity, key) {
            var properties = InputsMetaData.get(entity, key);
            return properties && (properties === null || properties === void 0 ? void 0 : properties.get('inputType')) != exports.InputTypes.COMPOSITE
                ? true
                : false;
        };
        FormEntityProcessorService.prototype.isComposite = function (entity, key) {
            var properties = InputsMetaData.get(entity, key);
            return properties && (properties === null || properties === void 0 ? void 0 : properties.get('inputType')) == exports.InputTypes.COMPOSITE
                ? true
                : false;
        };
        return FormEntityProcessorService;
    }());
    FormEntityProcessorService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: FormEntityProcessorService, deps: [{ token: InputProcessorService }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    FormEntityProcessorService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: FormEntityProcessorService });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: FormEntityProcessorService, decorators: [{
                type: i0.Injectable
            }], ctorParameters: function () { return [{ type: InputProcessorService }]; } });

    var EntityRegistry = /** @class */ (function () {
        function EntityRegistry() {
        }
        EntityRegistry.add = function (name, declaredClass) {
            EntityRegistry.registry.set(name, declaredClass);
        };
        EntityRegistry.get = function (name) {
            return EntityRegistry.registry.get(name);
        };
        EntityRegistry.prototype.get = function (name) {
            return EntityRegistry.registry.get(name);
        };
        return EntityRegistry;
    }());
    EntityRegistry.registry = new Map();
    EntityRegistry.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: EntityRegistry, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    EntityRegistry.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: EntityRegistry });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: EntityRegistry, decorators: [{
                type: i0.Injectable
            }] });

    var InputAnchorDirective = /** @class */ (function () {
        function InputAnchorDirective(viewContainerRef) {
            this.viewContainerRef = viewContainerRef;
        }
        return InputAnchorDirective;
    }());
    InputAnchorDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: InputAnchorDirective, deps: [{ token: i0__namespace.ViewContainerRef }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    InputAnchorDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: InputAnchorDirective, selector: "[dfInputAnchor]", ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: InputAnchorDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[dfInputAnchor]',
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.ViewContainerRef }]; } });

    var InputComponentRegistry = /** @class */ (function () {
        function InputComponentRegistry() {
        }
        InputComponentRegistry.get = function (key) {
            return InputComponentRegistry.registeredInputs.get(key);
        };
        InputComponentRegistry.set = function (key, component) {
            InputComponentRegistry.registeredInputs.set(key, component);
        };
        return InputComponentRegistry;
    }());
    InputComponentRegistry.registeredInputs = new Map();

    var InputResolverComponent = /** @class */ (function () {
        function InputResolverComponent(resolver) {
            this.resolver = resolver;
            this.inputComponentsRegistry = InputComponentRegistry;
        }
        InputResolverComponent.prototype.ngOnChanges = function (changes) { };
        InputResolverComponent.prototype.ngOnInit = function () {
            if (!this.getTemplateRef()) {
                this.renderInputComponent();
            }
        };
        InputResolverComponent.prototype.getInputNode = function () {
            return this.inputNode;
        };
        InputResolverComponent.prototype.getTemplateRef = function () {
            return (this.inputTemplatesMap.get(this.inputNode.getProperty('inputType')) ||
                null);
        };
        InputResolverComponent.prototype.getInputComponent = function () {
            return this.inputComponentsRegistry.get(this.inputNode.getProperty('inputType'));
        };
        InputResolverComponent.prototype.renderInputComponent = function () {
            var inputComponent = this.getInputComponent();
            if (inputComponent) {
                var viewContainerRef = this.inputAnchor.viewContainerRef;
                viewContainerRef.clear();
                var componentFactoryResolver = this.resolver.resolveComponentFactory(inputComponent);
                var componentRef = viewContainerRef.createComponent(componentFactoryResolver);
                componentRef.instance.initialize(this.getInputNode());
            }
        };
        return InputResolverComponent;
    }());
    InputResolverComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: InputResolverComponent, deps: [{ token: i0__namespace.ComponentFactoryResolver }], target: i0__namespace.ɵɵFactoryTarget.Component });
    InputResolverComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: InputResolverComponent, selector: "[df-input-resolver]", inputs: { inputNode: "inputNode", inputTemplatesMap: "inputTemplatesMap" }, viewQueries: [{ propertyName: "inputAnchor", first: true, predicate: InputAnchorDirective, descendants: true, static: true }], usesOnChanges: true, ngImport: i0__namespace, template: "<ng-container\n  *ngIf=\"getTemplateRef()\"\n  [ngTemplateOutlet]=\"getTemplateRef()\"\n  [ngTemplateOutletContext]=\"{ $implicit: getInputNode() }\"\n></ng-container>\n\n<ng-template dfInputAnchor></ng-template>\n", styles: [""], directives: [{ type: i2__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2__namespace.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: InputAnchorDirective, selector: "[dfInputAnchor]" }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: InputResolverComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: '[df-input-resolver]',
                        templateUrl: './input-resolver.component.html',
                        styleUrls: ['./input-resolver.component.css'],
                        // changeDetection: ChangeDetectionStrategy.OnPush,
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.ComponentFactoryResolver }]; }, propDecorators: { inputNode: [{
                    type: i0.Input
                }], inputTemplatesMap: [{
                    type: i0.Input
                }], inputAnchor: [{
                    type: i0.ViewChild,
                    args: [InputAnchorDirective, { static: true }]
                }] } });

    var DynamicFormComponent = /** @class */ (function () {
        function DynamicFormComponent(formEntityProcessorService, dynamicFormContextService, entityRegistry) {
            this.formEntityProcessorService = formEntityProcessorService;
            this.dynamicFormContextService = dynamicFormContextService;
            this.entityRegistry = entityRegistry;
            this.includeDisabled = false; // todo add in documentation
            this.submitEvent = new i0.EventEmitter();
            this.changEvent = new i0.EventEmitter();
            this.buttonClickEvent = new i0.EventEmitter();
            this.inputTemplateMap = new Map();
        }
        DynamicFormComponent.prototype.ngAfterContentInit = function () {
            var _this = this;
            // console.log('buttonTemplateQueryList', this.buttonTemplateQueryList);
            this.inputTemplateQueryList.forEach(function (item) {
                _this.inputTemplateMap.set(item.getInputType(), item.getTemplateRef());
            });
        };
        DynamicFormComponent.prototype.ngOnInit = function () { };
        DynamicFormComponent.prototype.ngOnChanges = function (changes) {
            var _this = this;
            var _a;
            if (changes.entityName) {
                var entityClass = this.entityRegistry.get(changes.entityName.currentValue);
                if (entityClass) {
                    this.formEntity = new entityClass();
                    this.inputTree = this.formEntityProcessorService.process(this.formEntity, this.useContext);
                    console.log(this.inputTree);
                    this.dynamicFormContextService.setContext(this.inputTree.getControl().value);
                    this.inputTree.getControl().valueChanges.subscribe(function (val) {
                        _this.dynamicFormContextService.setContext(val);
                    });
                    (_a = this.inputTree.getControl()) === null || _a === void 0 ? void 0 : _a.valueChanges.subscribe(function (value) {
                        _this.changEvent.emit(value);
                    });
                    // check  enabled ot disabled status
                    this.formEntityProcessorService.applyEnableFn(this.inputTree);
                }
            }
            if (changes.initialValue && changes.initialValue.currentValue) {
                var value = changes.initialValue.currentValue;
                this.inputTree.getControl().reset(value, { emitEvent: false });
                // update value and checks for validation its important to start with valid data
                this.inputTree.getControl().updateValueAndValidity();
                // check  enabled ot disabled status
                this.formEntityProcessorService.applyEnableFn(this.inputTree);
            }
        };
        DynamicFormComponent.prototype.onSubmit = function (v) {
            var _a, _b;
            (_a = this.inputTree.getControl()) === null || _a === void 0 ? void 0 : _a.markAllAsTouched();
            // console.log(this.inputTree.getControl());
            if ((_b = this.inputTree.getControl()) === null || _b === void 0 ? void 0 : _b.valid) {
                this.submitEvent.emit(this.formValue);
            }
        };
        DynamicFormComponent.prototype.onClick = function (action) {
            if (action.type == 'button') {
                this.buttonClickEvent.emit({
                    actionId: action.id,
                    formValue: this.formValue,
                });
            }
            else if (typeof action == 'string') {
                this.buttonClickEvent.emit({
                    actionId: action,
                    formValue: this.formValue,
                });
            }
        };
        Object.defineProperty(DynamicFormComponent.prototype, "formValue", {
            get: function () {
                if (this.includeDisabled) {
                    return this.valueTransformer
                        ? this.valueTransformer.transform(this.inputTree.getControl().getRawValue())
                        : this.inputTree.getControl().getRawValue();
                }
                else {
                    return this.valueTransformer
                        ? this.valueTransformer.transform(this.inputTree.getControl().value)
                        : this.inputTree.getControl().value;
                }
            },
            enumerable: false,
            configurable: true
        });
        DynamicFormComponent.prototype.markAllAsTouched = function () {
            var _a;
            (_a = this.inputTree.getControl()) === null || _a === void 0 ? void 0 : _a.markAllAsTouched();
        };
        DynamicFormComponent.prototype.markAsTouched = function (path) {
            throw new Error('Method not implemented.');
        };
        DynamicFormComponent.prototype.markAsInvalid = function (path, errConfig) {
            throw new Error('Method not implemented.');
        };
        DynamicFormComponent.prototype.markFieldAsInvalid = function (path, errConfig) {
            throw new Error('Method not implemented.');
        };
        DynamicFormComponent.prototype.disable = function (path) {
            throw new Error('Method not implemented.');
        };
        DynamicFormComponent.prototype.enable = function (path) {
            throw new Error('Method not implemented.');
        };
        DynamicFormComponent.prototype.setReadonly = function (path) {
            throw new Error('Method not implemented.');
        };
        DynamicFormComponent.prototype.unsetReadonly = function (path) {
            throw new Error('Method not implemented.');
        };
        DynamicFormComponent.prototype.getRowValue = function () {
            return this.inputTree.getControl().getRawValue();
        };
        DynamicFormComponent.prototype.getValue = function () {
            return this.inputTree.getControl().value;
        };
        DynamicFormComponent.prototype.fireAction = function (id) {
            throw new Error('Method not implemented.');
        };
        DynamicFormComponent.prototype.reset = function (value, emitEvent) {
            this.inputTree.getControl().reset(value || {}, { emitEvent: emitEvent });
        };
        DynamicFormComponent.prototype.patch = function (value, emitEvent) {
            this.inputTree
                .getControl()
                .reset(ObjectUtil.patchObject(this.inputTree.getControl().getRawValue(), value), {
                emitEvent: emitEvent,
            });
        };
        DynamicFormComponent.prototype.getName = function () {
            return this.entityName;
        };
        DynamicFormComponent.prototype.isValid = function () {
            return this.inputTree.getControl().valid;
        };
        return DynamicFormComponent;
    }());
    DynamicFormComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: DynamicFormComponent, deps: [{ token: FormEntityProcessorService }, { token: DynamicFormContextService }, { token: EntityRegistry }], target: i0__namespace.ɵɵFactoryTarget.Component });
    DynamicFormComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: DynamicFormComponent, selector: "d-form", inputs: { entityName: "entityName", initialValue: "initialValue", useContext: "useContext", valueTransformer: "valueTransformer", includeDisabled: "includeDisabled" }, outputs: { submitEvent: "submitEvent", changEvent: "changeEvent", buttonClickEvent: "buttonClickEvent" }, providers: [DynamicFormContextService], queries: [{ propertyName: "inputTemplateQueryList", predicate: InputTemplateDirective }, { propertyName: "buttonTemplateQueryList", predicate: ButtonTemplateDirective }], usesOnChanges: true, ngImport: i0__namespace, template: "<form\n  *ngIf=\"inputTree\"\n  class=\"row g-3 d-form\"\n  [formGroup]=\"$any(inputTree!.getControl())\"\n  (ngSubmit)=\"onSubmit($event)\"\n>\n  <ng-container *ngFor=\"let inputNode of inputTree.getChildren()\">\n    <!-- <div\n      lib-dynamic-form-input\n      [inputNode]=\"inputNode\"\n      [class]=\"'col-md-' + inputNode.getProperty('width')\"\n    ></div> -->\n\n    <div\n      [class]=\"'col-md-' + inputNode.getProperty('width')\"\n      df-input-resolver\n      [inputNode]=\"inputNode\"\n      [inputTemplatesMap]=\"inputTemplateMap\"\n    ></div>\n  </ng-container>\n\n  <div class=\"col-12 d-buttons-row\">\n    <ng-container\n      *ngIf=\"buttonTemplateQueryList.length > 0; else actionsFromMeta\"\n    >\n      <ng-container\n        *ngFor=\"let buttonDir of buttonTemplateQueryList\"\n        [ngTemplateOutlet]=\"buttonDir.getTemplate()\"\n        [ngTemplateOutletContext]=\"{ $implicit: inputTree }\"\n      ></ng-container>\n    </ng-container>\n    <ng-template #actionsFromMeta>\n      <div\n        class=\"col-lg-1 col-md-3 col-sm-3\"\n        *ngFor=\"let action of inputTree.getProperty('actions')\"\n      >\n        <button\n          [type]=\"action.type\"\n          [class]=\"'d-form-btn ' + (action.class || 'btn btn-primary')\"\n          (click)=\"onClick(action)\"\n        >\n          {{ action?.label }}\n        </button>\n      </div>\n    </ng-template>\n  </div>\n</form>\n<ng-content></ng-content>\n", styles: [""], components: [{ type: InputResolverComponent, selector: "[df-input-resolver]", inputs: ["inputNode", "inputTemplatesMap"] }], directives: [{ type: i2__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2__namespace$1.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { type: i2__namespace$1.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i2__namespace$1.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i2__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i2__namespace.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: DynamicFormComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'd-form',
                        templateUrl: './dynamic-form.component.html',
                        styleUrls: ['./dynamic-form.component.css'],
                        providers: [DynamicFormContextService],
                    }]
            }], ctorParameters: function () { return [{ type: FormEntityProcessorService }, { type: DynamicFormContextService }, { type: EntityRegistry }]; }, propDecorators: { entityName: [{
                    type: i0.Input,
                    args: ['entityName']
                }], initialValue: [{
                    type: i0.Input,
                    args: ['initialValue']
                }], useContext: [{
                    type: i0.Input,
                    args: ['useContext']
                }], valueTransformer: [{
                    type: i0.Input,
                    args: ['valueTransformer']
                }], includeDisabled: [{
                    type: i0.Input,
                    args: ['includeDisabled']
                }], submitEvent: [{
                    type: i0.Output,
                    args: ['submitEvent']
                }], changEvent: [{
                    type: i0.Output,
                    args: ['changeEvent']
                }], buttonClickEvent: [{
                    type: i0.Output,
                    args: ['buttonClickEvent']
                }], inputTemplateQueryList: [{
                    type: i0.ContentChildren,
                    args: [InputTemplateDirective]
                }], buttonTemplateQueryList: [{
                    type: i0.ContentChildren,
                    args: [ButtonTemplateDirective]
                }] } });

    var MessageStringInterpolation = /** @class */ (function () {
        function MessageStringInterpolation() {
        }
        // private readonly  interpolation_pattern = /\${([^\${}]*)}/g;
        MessageStringInterpolation.interpolate = function (message, obj) {
            // @ts-ignore
            return message.replace(/\${([^\${}]*)}/g, function (a, b) {
                // @ts-ignore
                var r = obj[b];
                // console.log("interpolate", a, b, obj);
                return typeof r === 'string' || typeof r === 'number' ? r : r.toString(); //a;
            });
        };
        return MessageStringInterpolation;
    }());

    var ErrorMessagePipe = /** @class */ (function () {
        function ErrorMessagePipe() {
        }
        ErrorMessagePipe.prototype.transform = function (value) {
            var validationError = value.getControl().errors;
            if (validationError) {
                var errorString = null;
                var key = Object.keys(validationError)[0];
                errorString = value.getError(key) || '';
                return MessageStringInterpolation.interpolate(errorString || '', validationError[key]);
            }
            else {
                return null;
            }
        };
        return ErrorMessagePipe;
    }());
    ErrorMessagePipe.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: ErrorMessagePipe, deps: [], target: i0__namespace.ɵɵFactoryTarget.Pipe });
    ErrorMessagePipe.ɵpipe = i0__namespace.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: ErrorMessagePipe, name: "errorMessage", pure: false });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: ErrorMessagePipe, decorators: [{
                type: i0.Pipe,
                args: [{
                        name: 'errorMessage',
                        pure: false,
                    }]
            }] });

    var InputComponent = /** @class */ (function () {
        function InputComponent() {
        }
        InputComponent.prototype.ngOnInit = function () { };
        InputComponent.prototype.getInputNode = function () {
            return this.inputNode;
        };
        InputComponent.prototype.initialize = function (input) {
            this.inputNode = input;
            this.value = this.getValue();
            this.onChange();
        };
        InputComponent.prototype.setValue = function (val) {
            this.inputNode
                .getControl()
                .setValue(val, { self: false, emitEvent: false });
        };
        InputComponent.prototype.commitChanges = function () {
            this.inputNode.getControl().updateValueAndValidity();
        };
        InputComponent.prototype.getValue = function () {
            return this.inputNode.getControl().value;
        };
        InputComponent.prototype.onChange = function () {
            var _this = this;
            this.inputNode.getControl().valueChanges.subscribe(function (val) {
                if (JSON.stringify(val) == JSON.stringify(_this.value)) {
                    return;
                }
                else {
                    _this.value = val;
                }
            });
        };
        return InputComponent;
    }());
    InputComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: InputComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    InputComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: InputComponent, selector: "[lib-input]", ngImport: i0__namespace, template: "<div>welcome input component</div>\n\n<!-- <ng-container\n  *ngIf=\"\n    inputDescription.getProperty('inputType') == INPUT_TYPES.TEXT ||\n    inputDescription.getProperty('inputType') == INPUT_TYPES.NUMBER ||\n    inputDescription.getProperty('inputType') == INPUT_TYPES.DATE\n  \"\n>\n  <div [class]=\"inputContainerClasses\">\n    <label\n      *ngIf=\"!isFloatingLabel\"\n      [attr.for]=\"inputDescription.getProperty('id')\"\n      [ngClass]=\"labelClasses\"\n      [ngClass]=\"{\n        'required-control-label': inputDescription.getProperty('required'),\n        'invalid-label':\n          inputDescription.getControl()?.touched &&\n          inputDescription.getControl()?.invalid\n      }\"\n      >{{ inputDescription.getProperty(\"label\") }}</label\n    >\n    <div [class]=\"inputDivClasses\">\n      <input\n        class=\"form-control\"\n        [ngClass]=\"{\n          'is-invalid':\n            inputDescription.getControl()?.touched &&\n            inputDescription.getControl()?.invalid\n        }\"\n        [placeholder]=\"inputDescription.getProperty('placeHolder') || ''\"\n        [id]=\"inputDescription.getProperty('id')\"\n        [type]=\"inputDescription.getProperty('type')\"\n        [formControl]=\"$any(inputDescription.getControl())\"\n        [name]=\"inputDescription.getProperty('name')\"\n        [attr.readonly]=\"inputDescription.getProperty('readonly')\"\n      />\n\n      <label\n        *ngIf=\"isFloatingLabel\"\n        [attr.for]=\"inputDescription.getProperty('id')\"\n        [ngClass]=\"{\n          'required-control-label': inputDescription.getProperty('required'),\n          'invalid-label':\n            inputDescription.getControl()?.touched &&\n            inputDescription.getControl()?.invalid\n        }\"\n        >{{ inputDescription.getProperty(\"label\") }}</label\n      >\n      <div\n        class=\"invalid-feedback\"\n        *ngIf=\"\n          inputDescription.getControl()?.touched &&\n          inputDescription.getControl()?.invalid\n        \"\n      >\n        {{ inputDescription | errorMessage }}\n      </div>\n    </div>\n  </div>\n</ng-container> -->\n\n<!-- \n<ng-container\n  *ngIf=\"inputDescription.getProperty('inputType') == INPUT_TYPES.SELECT\"\n>\n  <div [class]=\"inputContainerClasses\">\n    <label\n      *ngIf=\"!isFloatingLabel\"\n      [attr.for]=\"inputDescription.getProperty('id')\"\n      [ngClass]=\"labelClasses\"\n      [ngClass]=\"{\n        'required-control-label': inputDescription.getProperty('required'),\n        'invalid-label':\n          inputDescription.getControl()?.touched &&\n          inputDescription.getControl()?.invalid\n      }\"\n      >{{ inputDescription.getProperty(\"label\") }}</label\n    >\n    <div [class]=\"inputDivClasses\">\n      <select\n        class=\"form-select\"\n        [ngClass]=\"{\n          'is-invalid':\n            inputDescription.getControl()?.touched &&\n            inputDescription.getControl()?.invalid\n        }\"\n        [id]=\"inputDescription.getProperty('id')\"\n        [formControl]=\"$any(inputDescription.getControl())\"\n        [name]=\"inputDescription.getProperty('name')\"\n        [compareWith]=\"inputDescription.getProperty('compareWith')\"\n      >\n        <option\n          *ngFor=\"\n            let opt of dataLoader.load(\n              inputDescription.getProperty('dataSource')\n            ) | async\n          \"\n          [ngValue]=\"\n            opt[inputDescription.getProperty('bindValue')]\n              ? opt[inputDescription.getProperty('bindValue')]\n              : opt\n          \"\n        >\n          {{ opt[inputDescription.getProperty(\"bindLabel\")] }}\n        </option>\n      </select>\n      <label\n        *ngIf=\"isFloatingLabel\"\n        [attr.for]=\"inputDescription.getProperty('id')\"\n        [ngClass]=\"{\n          'required-control-label': inputDescription.getProperty('required'),\n          'invalid-label':\n            inputDescription.getControl()?.touched &&\n            inputDescription.getControl()?.invalid\n        }\"\n        >{{ inputDescription.getProperty(\"label\") }}</label\n      >\n      <div\n        class=\"invalid-feedback\"\n        *ngIf=\"\n          inputDescription.getControl()?.touched &&\n          inputDescription.getControl()?.invalid\n        \"\n      >\n        {{ inputDescription | errorMessage }}\n      </div>\n    </div>\n  </div>\n</ng-container> -->\n\n<!-- <ng-container\n  *ngIf=\"inputDescription.getProperty('inputType') == INPUT_TYPES.CHECKBOX\"\n>\n  <div [class]=\"inputContainerClasses\">\n    <div class=\"form-check\">\n      <input\n        class=\"form-check-input\"\n        [ngClass]=\"{\n          'is-invalid':\n            inputDescription.getControl()?.touched &&\n            inputDescription.getControl()?.invalid\n        }\"\n        [id]=\"inputDescription.getProperty('id')\"\n        type=\"checkbox\"\n        [formControl]=\"$any(inputDescription.getControl())\"\n        [name]=\"inputDescription.getProperty('name')\"\n      />\n      <label\n        [attr.for]=\"inputDescription.getProperty('id')\"\n        class=\"form-check-label\"\n        [ngClass]=\"{\n          'required-control-label': inputDescription.getProperty('required'),\n          'invalid-label':\n            inputDescription.getControl()?.touched &&\n            inputDescription.getControl()?.invalid\n        }\"\n        >{{ inputDescription.getProperty(\"label\") }}</label\n      >\n      <div\n        class=\"invalid-feedback\"\n        *ngIf=\"\n          inputDescription.getControl()?.touched &&\n          inputDescription.getControl()?.invalid\n        \"\n      >\n        {{ inputDescription | errorMessage }}\n      </div>\n    </div>\n  </div>\n</ng-container> -->\n\n<!-- <ng-container\n  *ngIf=\"inputDescription.getProperty('inputType') == INPUT_TYPES.RADIO_BUTTONS\"\n>\n  <fieldset class=\"row mt-3 mb-3\">\n    <legend [ngClass]=\"radioLegendClasses\" class=\"col-form-label\">\n      {{ inputDescription.getProperty(\"legend\") }}\n    </legend>\n\n  \n    <div [ngClass]=\"radioInputContainerClasses\">\n      <div class=\"row mt-1 mb-1\">\n        <div\n          [class]=\"'col-sm-' + inputDescription.getProperty('inputWidth')\"\n          *ngFor=\"\n            let opt of dataLoader.load(\n              inputDescription.getProperty('dataSource')\n            ) | async;\n            let i = index\n          \"\n        >\n          <input\n            class=\"form-check-input mr-50\"\n            [id]=\"inputDescription.getProperty('id') + i\"\n            type=\"radio\"\n            [formControl]=\"$any(inputDescription.getControl())\"\n            [value]=\"\n              inputDescription.getProperty('bindValue')\n                ? opt[inputDescription.getProperty('bindValue')]\n                : opt\n            \"\n            [name]=\"inputDescription.getProperty('name')\"\n          />\n          <label\n            class=\"form-check-label\"\n            [attr.for]=\"inputDescription.getProperty('id') + i\"\n          >\n            {{ opt[inputDescription.getProperty(\"bindLabel\")] }}\n          </label>\n        </div>\n      </div>\n    </div>\n  </fieldset>\n</ng-container> -->\n\n<!-- <ng-container\n  *ngIf=\"inputDescription.getProperty('inputType') == INPUT_TYPES.COMPOSITE\"\n>\n  <fieldset class=\"row g-3\">\n    <legend [ngClass]=\"compositeLegendClasses\" class=\"col-form-label\">\n      {{ inputDescription.getProperty(\"legend\") }}\n    </legend>\n\n    <div [ngClass]=\"compositeInputContainerClasses\">\n      <div class=\"row g-3\">\n        <ng-container *ngFor=\"let childInput of inputDescription.getChildren()\">\n          <div\n            lib-input\n            [inputDescription]=\"childInput\"\n            [labelStyling]=\"inputDescription.getProperty('labelStyling')\"\n            [class]=\"'col-md-' + childInput.getProperty('width')\"\n          ></div>\n        </ng-container>\n      </div>\n    </div>\n  </fieldset>\n\n  \n</ng-container> -->\n", styles: [""] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: InputComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: '[lib-input]',
                        templateUrl: './input.component.html',
                        styleUrls: ['./input.component.css'],
                    }]
            }], ctorParameters: function () { return []; } });

    function DynamicFormInput(specs) {
        return function (constructor) {
            if (specs.inputType.toUpperCase() == exports.InputTypes.COMPOSITE &&
                InputComponentRegistry.get(exports.InputTypes.COMPOSITE)) {
                console.error("can't set inputType to 'COMPOSITE' its reserved for internal use, " +
                    'correct inputType in DynamicFormInput(specs: { inputType: string }) for class ' +
                    constructor);
                return constructor;
            }
            InputComponentRegistry.set(specs.inputType.toUpperCase(), constructor);
            return constructor;
        };
    }

    var DateInputComponent = /** @class */ (function (_super) {
        __extends(DateInputComponent, _super);
        function DateInputComponent() {
            return _super.call(this) || this;
        }
        DateInputComponent.prototype.ngOnInit = function () { };
        return DateInputComponent;
    }(InputComponent));
    DateInputComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: DateInputComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    DateInputComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: DateInputComponent, selector: "lib-date-input", usesInheritance: true, ngImport: i0__namespace, template: "<label\n  [attr.for]=\"getInputNode().getProperty('id')\"\n  class=\"d-form-label form-label\"\n  [ngClass]=\"{\n    required: getInputNode().getProperty('required'),\n    'invalid-label':\n      getInputNode().getControl()?.touched &&\n      getInputNode().getControl()?.invalid\n  }\"\n  >{{ getInputNode().getProperty(\"label\") }}\n</label>\n<input\n  class=\"form-control d-form-input\"\n  [ngClass]=\"{\n    invalid:\n      getInputNode().getControl()?.touched &&\n      getInputNode().getControl()?.invalid,\n    pending: getInputNode().isPending()\n  }\"\n  [placeholder]=\"getInputNode().getProperty('placeHolder') || ''\"\n  [id]=\"getInputNode().getProperty('id')\"\n  [type]=\"getInputNode().getProperty('type')\"\n  [formControl]=\"$any(getInputNode().getControl())\"\n  [name]=\"getInputNode().getProperty('name')\"\n  [attr.readonly]=\"getInputNode().getProperty('readonly')\"\n/>\n\n<div class=\"hint\">\n  {{\n    getInputNode().getControl()?.touched && getInputNode().getControl()?.invalid\n      ? (getInputNode() | errorMessage)\n      : getInputNode().getProperty(\"hint\")\n  }}\n</div>\n", styles: [""], directives: [{ type: i2__namespace.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i2__namespace$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i2__namespace$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2__namespace$1.FormControlDirective, selector: "[formControl]", inputs: ["disabled", "formControl", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }], pipes: { "errorMessage": ErrorMessagePipe } });
    DateInputComponent = __decorate([
        DynamicFormInput({ inputType: 'date' })
    ], DateInputComponent);
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: DateInputComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'lib-date-input',
                        templateUrl: './date-input.component.html',
                        styleUrls: ['./date-input.component.css'],
                    }]
            }], ctorParameters: function () { return []; } });

    var NumberInputComponent = /** @class */ (function (_super) {
        __extends(NumberInputComponent, _super);
        function NumberInputComponent() {
            return _super.call(this) || this;
        }
        NumberInputComponent.prototype.ngOnInit = function () { };
        return NumberInputComponent;
    }(InputComponent));
    NumberInputComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: NumberInputComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    NumberInputComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: NumberInputComponent, selector: "lib-number-input", usesInheritance: true, ngImport: i0__namespace, template: "<label\n  [attr.for]=\"getInputNode().getProperty('id')\"\n  class=\"d-form-label form-label\"\n  [ngClass]=\"{\n    required: getInputNode().getProperty('required'),\n    'invalid-label':\n      getInputNode().getControl()?.touched &&\n      getInputNode().getControl()?.invalid\n  }\"\n>\n  {{ getInputNode().getProperty(\"label\") }}\n</label>\n<input\n  class=\"form-control d-form-input\"\n  [ngClass]=\"{\n    invalid:\n      getInputNode().getControl()?.touched &&\n      getInputNode().getControl()?.invalid,\n    pending: getInputNode().isPending()\n  }\"\n  [placeholder]=\"getInputNode().getProperty('placeHolder') || ''\"\n  [id]=\"getInputNode().getProperty('id')\"\n  [type]=\"getInputNode().getProperty('type')\"\n  [formControl]=\"$any(getInputNode().getControl())\"\n  [name]=\"getInputNode().getProperty('name')\"\n  [attr.readonly]=\"getInputNode().getProperty('readonly')\"\n/>\n\n<div class=\"hint\">\n  {{\n    getInputNode().getControl()?.touched && getInputNode().getControl()?.invalid\n      ? (getInputNode() | errorMessage)\n      : getInputNode().getProperty(\"hint\")\n  }}\n</div>\n", styles: [""], directives: [{ type: i2__namespace.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i2__namespace$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i2__namespace$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2__namespace$1.FormControlDirective, selector: "[formControl]", inputs: ["disabled", "formControl", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }], pipes: { "errorMessage": ErrorMessagePipe } });
    NumberInputComponent = __decorate([
        DynamicFormInput({ inputType: 'number' })
    ], NumberInputComponent);
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: NumberInputComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'lib-number-input',
                        templateUrl: './number-input.component.html',
                        styleUrls: ['./number-input.component.css'],
                    }]
            }], ctorParameters: function () { return []; } });

    var TextInputComponent = /** @class */ (function (_super) {
        __extends(TextInputComponent, _super);
        function TextInputComponent() {
            return _super.call(this) || this;
        }
        TextInputComponent.prototype.ngOnInit = function () { };
        return TextInputComponent;
    }(InputComponent));
    TextInputComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: TextInputComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    TextInputComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: TextInputComponent, selector: "lib-text-input", usesInheritance: true, ngImport: i0__namespace, template: "<label\n  [attr.for]=\"getInputNode().getProperty('id')\"\n  class=\"d-form-label form-label\"\n  [ngClass]=\"{\n    required: getInputNode().getProperty('required'),\n    'invalid-label':\n      getInputNode().getControl()?.touched &&\n      getInputNode().getControl()?.invalid\n  }\"\n  >{{ getInputNode().getProperty(\"label\") }}</label\n>\n<input\n  class=\"form-control d-form-input\"\n  [ngClass]=\"{\n    invalid:\n      getInputNode().getControl()?.touched &&\n      getInputNode().getControl()?.invalid,\n    pending: getInputNode().isPending()\n  }\"\n  [placeholder]=\"getInputNode().getProperty('placeHolder') || ''\"\n  [id]=\"getInputNode().getProperty('id')\"\n  [type]=\"getInputNode().getProperty('type')\"\n  [formControl]=\"$any(getInputNode().getControl())\"\n  [name]=\"getInputNode().getProperty('name')\"\n  [attr.readonly]=\"getInputNode().getProperty('readonly')\"\n/>\n\n<div class=\"hint\">\n  {{\n    getInputNode().getControl()?.touched && getInputNode().getControl()?.invalid\n      ? (getInputNode() | errorMessage)\n      : getInputNode().getProperty(\"hint\")\n  }}\n</div>\n", styles: [""], directives: [{ type: i2__namespace.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i2__namespace$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i2__namespace$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2__namespace$1.FormControlDirective, selector: "[formControl]", inputs: ["disabled", "formControl", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }], pipes: { "errorMessage": ErrorMessagePipe } });
    TextInputComponent = __decorate([
        DynamicFormInput({ inputType: 'TEXT' })
    ], TextInputComponent);
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: TextInputComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'lib-text-input',
                        templateUrl: './text-input.component.html',
                        styleUrls: ['./text-input.component.css'],
                        // changeDetection: ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () { return []; } });

    var CheckboxInputComponent = /** @class */ (function (_super) {
        __extends(CheckboxInputComponent, _super);
        function CheckboxInputComponent() {
            return _super.call(this) || this;
        }
        CheckboxInputComponent.prototype.ngOnInit = function () { };
        return CheckboxInputComponent;
    }(InputComponent));
    CheckboxInputComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: CheckboxInputComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    CheckboxInputComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: CheckboxInputComponent, selector: "lib-checkbox-input", usesInheritance: true, ngImport: i0__namespace, template: "<div class=\"form-check\">\n  <input\n    class=\"form-check-input d-form-input d-form-check\"\n    [ngClass]=\"{\n      invalid:\n        getInputNode().getControl()?.touched &&\n        getInputNode().getControl()?.invalid\n    }\"\n    [id]=\"getInputNode().getProperty('id')\"\n    type=\"checkbox\"\n    [formControl]=\"$any(getInputNode().getControl())\"\n    [name]=\"getInputNode().getProperty('name')\"\n  />\n\n  <label\n    [attr.for]=\"getInputNode().getProperty('id')\"\n    class=\"d-form-label form-label form-check-label\"\n    [ngClass]=\"{\n      required: getInputNode().getProperty('required'),\n      'invalid-label':\n        getInputNode().getControl()?.touched &&\n        getInputNode().getControl()?.invalid\n    }\"\n    >{{ getInputNode().getProperty(\"label\") }}\n  </label>\n  <div class=\"hint\">\n    {{\n      getInputNode().getControl()?.touched &&\n      getInputNode().getControl()?.invalid\n        ? (getInputNode() | errorMessage)\n        : getInputNode().getProperty(\"hint\")\n    }}\n  </div>\n</div>\n", styles: [""], directives: [{ type: i2__namespace$1.CheckboxControlValueAccessor, selector: "input[type=checkbox][formControlName],input[type=checkbox][formControl],input[type=checkbox][ngModel]" }, { type: i2__namespace.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i2__namespace$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2__namespace$1.FormControlDirective, selector: "[formControl]", inputs: ["disabled", "formControl", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }], pipes: { "errorMessage": ErrorMessagePipe } });
    CheckboxInputComponent = __decorate([
        DynamicFormInput({ inputType: 'checkbox' })
    ], CheckboxInputComponent);
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: CheckboxInputComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'lib-checkbox-input',
                        templateUrl: './checkbox-input.component.html',
                        styleUrls: ['./checkbox-input.component.css'],
                    }]
            }], ctorParameters: function () { return []; } });

    var NestedFormComponent = /** @class */ (function (_super) {
        __extends(NestedFormComponent, _super);
        function NestedFormComponent() {
            var _this = _super.call(this) || this;
            _this.templateMap = new Map();
            return _this;
        }
        NestedFormComponent.prototype.ngOnInit = function () { };
        return NestedFormComponent;
    }(InputComponent));
    NestedFormComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: NestedFormComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    NestedFormComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: NestedFormComponent, selector: "lib-nested-form", usesInheritance: true, ngImport: i0__namespace, template: "<fieldset [class]=\"'col-md-12 ' + getInputNode().getProperty('class')\">\n  <legend [class]=\"getInputNode().getProperty('legendClass')\">\n    {{ getInputNode().getProperty(\"legend\") }}\n  </legend>\n  <div class=\"row g-3\">\n    <ng-container *ngFor=\"let node of getInputNode().getChildren()\">\n      <div\n        [class]=\"'col-md-' + node.getProperty('width')\"\n        df-input-resolver\n        [inputNode]=\"node\"\n        [inputTemplatesMap]=\"templateMap\"\n      ></div>\n    </ng-container>\n  </div>\n</fieldset>\n", styles: [""], components: [{ type: InputResolverComponent, selector: "[df-input-resolver]", inputs: ["inputNode", "inputTemplatesMap"] }], directives: [{ type: i2__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }] });
    NestedFormComponent = __decorate([
        DynamicFormInput({ inputType: 'COMPOSITE' })
    ], NestedFormComponent);
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: NestedFormComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'lib-nested-form',
                        templateUrl: './nested-form.component.html',
                        styleUrls: ['./nested-form.component.css'],
                    }]
            }], ctorParameters: function () { return []; } });

    var DataLoaderService = /** @class */ (function () {
        function DataLoaderService(httpClient) {
            this.httpClient = httpClient;
            this.dataSources = new Map(); //used to return the same observable to stop async pipe from sending multiple http requests
        }
        DataLoaderService.prototype.load = function (dataSource) {
            if (dataSource instanceof URL) {
                if (!this.dataSources.get(dataSource.href)) {
                    this.dataSources.set(dataSource.href, this.httpClient.get(dataSource.href));
                }
                return this.dataSources.get(dataSource.href) || rxjs.of([]);
            }
            else if (Array.isArray(dataSource)) {
                return rxjs.of(dataSource);
            }
            else {
                return dataSource;
            }
        };
        return DataLoaderService;
    }());
    DataLoaderService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: DataLoaderService, deps: [{ token: i1__namespace.HttpClient }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    DataLoaderService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: DataLoaderService });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: DataLoaderService, decorators: [{
                type: i0.Injectable
            }], ctorParameters: function () { return [{ type: i1__namespace.HttpClient }]; } });

    var RadioButtonsInputComponent = /** @class */ (function (_super) {
        __extends(RadioButtonsInputComponent, _super);
        function RadioButtonsInputComponent(dataLoader) {
            var _this = _super.call(this) || this;
            _this.dataLoader = dataLoader;
            return _this;
        }
        RadioButtonsInputComponent.prototype.ngOnInit = function () { };
        return RadioButtonsInputComponent;
    }(InputComponent));
    RadioButtonsInputComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: RadioButtonsInputComponent, deps: [{ token: DataLoaderService }], target: i0__namespace.ɵɵFactoryTarget.Component });
    RadioButtonsInputComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: RadioButtonsInputComponent, selector: "lib-radio-buttons-input", providers: [DataLoaderService], usesInheritance: true, ngImport: i0__namespace, template: "<fieldset class=\"col-md-12\">\n  <legend class=\"form-label d-form-label radio-legend\">\n    {{ getInputNode().getProperty(\"legend\") }}\n  </legend>\n  <div class=\"row g-3\">\n    <div\n      [class]=\"'col-md-' + getInputNode().getProperty('inputWidth')\"\n      *ngFor=\"\n        let opt of dataLoader.load(getInputNode().getProperty('dataSource'))\n          | async;\n        let i = index\n      \"\n    >\n      <div class=\"form-check\">\n        <input\n          class=\"form-check-input d-form-input\"\n          [id]=\"getInputNode().getProperty('id') + i\"\n          type=\"radio\"\n          [formControl]=\"$any(getInputNode().getControl())\"\n          [value]=\"\n            getInputNode().getProperty('bindValue')\n              ? opt[getInputNode().getProperty('bindValue')]\n              : opt\n          \"\n          [name]=\"getInputNode().getProperty('name')\"\n        />\n\n        <label\n          class=\"form-check-label d-form-label\"\n          [attr.for]=\"getInputNode().getProperty('id') + i\"\n        >\n          {{ opt[getInputNode().getProperty(\"bindLabel\")] }}\n        </label>\n\n        <!-- <div class=\"hint\">\n            Lorem ipsum dolor sit amet consectetur adipisicing elit. Quisquam\n            hic\n          </div> -->\n      </div>\n    </div>\n  </div>\n</fieldset>\n", styles: [""], directives: [{ type: i2__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i2__namespace$1.RadioControlValueAccessor, selector: "input[type=radio][formControlName],input[type=radio][formControl],input[type=radio][ngModel]", inputs: ["name", "formControlName", "value"] }, { type: i2__namespace$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i2__namespace$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2__namespace$1.FormControlDirective, selector: "[formControl]", inputs: ["disabled", "formControl", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }], pipes: { "async": i2__namespace.AsyncPipe } });
    RadioButtonsInputComponent = __decorate([
        DynamicFormInput({ inputType: 'radio_buttons' })
    ], RadioButtonsInputComponent);
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: RadioButtonsInputComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'lib-radio-buttons-input',
                        templateUrl: './radio-buttons-input.component.html',
                        styleUrls: ['./radio-buttons-input.component.css'],
                        providers: [DataLoaderService],
                    }]
            }], ctorParameters: function () { return [{ type: DataLoaderService }]; } });

    var SelectInputComponent = /** @class */ (function (_super) {
        __extends(SelectInputComponent, _super);
        function SelectInputComponent(dataLoader) {
            var _this = _super.call(this) || this;
            _this.dataLoader = dataLoader;
            return _this;
        }
        SelectInputComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.defaultValueIndex =
                this.getInputNode().getProperty('defaultValueIndex');
            this.dataLoader
                .load(this.getInputNode().getProperty('dataSource'))
                .toPromise()
                .then(function (data) {
                _this.options = data;
                if (_this.defaultValueIndex !== undefined) {
                    _this.defaultValue = _this.options[_this.defaultValueIndex];
                    _this.getInputNode().getControl().setValue(_this.defaultValue, false);
                }
            });
        };
        return SelectInputComponent;
    }(InputComponent));
    SelectInputComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: SelectInputComponent, deps: [{ token: DataLoaderService }], target: i0__namespace.ɵɵFactoryTarget.Component });
    SelectInputComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: SelectInputComponent, selector: "lib-select-input", providers: [DataLoaderService], usesInheritance: true, ngImport: i0__namespace, template: "<label\n  [attr.for]=\"getInputNode().getProperty('id')\"\n  class=\"d-form-label form-label\"\n  [ngClass]=\"{\n    required: getInputNode().getProperty('required'),\n    'invalid-label':\n      getInputNode().getControl()?.touched &&\n      getInputNode().getControl()?.invalid\n  }\"\n  >{{ getInputNode().getProperty(\"label\") }}\n</label>\n\n<select\n  class=\"form-select d-form-input\"\n  [ngClass]=\"{\n    invalid:\n      getInputNode().getControl()?.touched &&\n      getInputNode().getControl()?.invalid,\n    pending: getInputNode().isPending()\n  }\"\n  [id]=\"getInputNode().getProperty('id')\"\n  [formControl]=\"$any(getInputNode().getControl())\"\n  [name]=\"getInputNode().getProperty('name')\"\n  [compareWith]=\"getInputNode().getProperty('compareWith')\"\n>\n  <option\n    *ngFor=\"\n      let opt of dataLoader.load(getInputNode().getProperty('dataSource'))\n        | async\n    \"\n    [ngValue]=\"\n      opt[getInputNode().getProperty('bindValue')]\n        ? opt[getInputNode().getProperty('bindValue')]\n        : opt\n    \"\n  >\n    {{ opt[getInputNode().getProperty(\"bindLabel\")] }}\n  </option>\n</select>\n<div class=\"hint\">\n  {{\n    getInputNode().getControl()?.touched && getInputNode().getControl()?.invalid\n      ? (getInputNode() | errorMessage)\n      : getInputNode().getProperty(\"hint\")\n  }}\n</div>\n", styles: [""], directives: [{ type: i2__namespace.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i2__namespace$1.SelectControlValueAccessor, selector: "select:not([multiple])[formControlName],select:not([multiple])[formControl],select:not([multiple])[ngModel]", inputs: ["compareWith"] }, { type: i2__namespace$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i2__namespace$1.FormControlDirective, selector: "[formControl]", inputs: ["disabled", "formControl", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { type: i2__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i2__namespace$1.NgSelectOption, selector: "option", inputs: ["ngValue", "value"] }, { type: i2__namespace$1.ɵNgSelectMultipleOption, selector: "option", inputs: ["ngValue", "value"] }], pipes: { "async": i2__namespace.AsyncPipe, "errorMessage": ErrorMessagePipe } });
    SelectInputComponent = __decorate([
        DynamicFormInput({ inputType: 'select' })
    ], SelectInputComponent);
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: SelectInputComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'lib-select-input',
                        templateUrl: './select-input.component.html',
                        styleUrls: ['./select-input.component.css'],
                        providers: [DataLoaderService],
                    }]
            }], ctorParameters: function () { return [{ type: DataLoaderService }]; } });

    var DynamicFormModule = /** @class */ (function () {
        function DynamicFormModule() {
        }
        // todo
        // replace ith with forRoot and forChild pattern
        DynamicFormModule.register = function (entities) {
            entities.forEach(function (entity) {
                var _a;
                var name = (_a = FormMetaData.get(entity.prototype)) === null || _a === void 0 ? void 0 : _a.get('name');
                if (name)
                    EntityRegistry.add(name, entity);
            });
            return {
                ngModule: DynamicFormModule,
                providers: [
                    FormEntityProcessorService,
                    EntityRegistry,
                    InputProcessorService,
                ],
            };
        };
        return DynamicFormModule;
    }());
    DynamicFormModule.defaultInputComponents = [
        TextInputComponent,
        NumberInputComponent,
        DateInputComponent,
        CheckboxInputComponent,
        NestedFormComponent,
        RadioButtonsInputComponent,
        SelectInputComponent,
    ];
    DynamicFormModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: DynamicFormModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    DynamicFormModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: DynamicFormModule, declarations: [DynamicFormComponent,
            ErrorMessagePipe,
            InputComponent,
            InputTemplateDirective,
            InputResolverComponent,
            InputAnchorDirective,
            TextInputComponent,
            NumberInputComponent,
            DateInputComponent,
            CheckboxInputComponent,
            NestedFormComponent,
            RadioButtonsInputComponent,
            SelectInputComponent,
            ButtonTemplateDirective], imports: [i2$1.CommonModule, i2.FormsModule, i2.ReactiveFormsModule], exports: [DynamicFormComponent,
            InputTemplateDirective,
            InputComponent,
            ButtonTemplateDirective,
            ErrorMessagePipe] });
    DynamicFormModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: DynamicFormModule, imports: [[i2$1.CommonModule, i2.FormsModule, i2.ReactiveFormsModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0__namespace, type: DynamicFormModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            DynamicFormComponent,
                            ErrorMessagePipe,
                            InputComponent,
                            InputTemplateDirective,
                            InputResolverComponent,
                            InputAnchorDirective,
                            TextInputComponent,
                            NumberInputComponent,
                            DateInputComponent,
                            CheckboxInputComponent,
                            NestedFormComponent,
                            RadioButtonsInputComponent,
                            SelectInputComponent,
                            ButtonTemplateDirective,
                        ],
                        imports: [i2$1.CommonModule, i2.FormsModule, i2.ReactiveFormsModule],
                        exports: [
                            DynamicFormComponent,
                            InputTemplateDirective,
                            InputComponent,
                            ButtonTemplateDirective,
                            ErrorMessagePipe
                        ],
                    }]
            }] });

    function FormEntity(formSpec) {
        return function (constructor) {
            FormMetaData.add(formSpec, constructor);
            return /** @class */ (function (_super) {
                __extends(class_1, _super);
                function class_1() {
                    var _this = _super.apply(this, __spreadArray([], __read(arguments))) || this;
                    _this.valueSetter = function (value) {
                        console.warn('implement smart setter for null value');
                        if (value == null) {
                        }
                        if (value instanceof Object) {
                            for (var key in _this) {
                                if (value[key] != undefined) {
                                    //@ts-ignore
                                    _this[key] = value[key];
                                }
                            }
                        }
                    };
                    return _this;
                }
                return class_1;
            }(constructor));
        };
    }

    function TextInput(specs) {
        return function (target, propertyKey) {
            InputsMetaData.add(Object.assign(Object.assign({}, specs), { inputType: exports.InputTypes.TEXT }), target, propertyKey);
        };
    }
    function NumberInput(specs) {
        return function (target, propertyKey) {
            specs.type = 'number';
            InputsMetaData.add(Object.assign(Object.assign({}, specs), { inputType: exports.InputTypes.NUMBER, type: 'number' }), target, propertyKey);
        };
    }
    function DateInput(specs) {
        return function (target, propertyKey) {
            InputsMetaData.add(Object.assign(Object.assign({}, specs), { inputType: exports.InputTypes.DATE }), target, propertyKey);
        };
    }
    function SelectInput(specs) {
        return function (target, propertyKey) {
            InputsMetaData.add(Object.assign(Object.assign({}, specs), { inputType: exports.InputTypes.SELECT }), target, propertyKey);
        };
    }
    function CheckboxInput(specs) {
        return function (target, propertyKey) {
            InputsMetaData.add(Object.assign(Object.assign({}, specs), { inputType: exports.InputTypes.CHECKBOX }), target, propertyKey);
        };
    }
    function RadioGroupInput(specs) {
        return function (target, propertyKey) {
            InputsMetaData.add(Object.assign(Object.assign({}, specs), { inputType: exports.InputTypes.RADIO_BUTTONS }), target, propertyKey);
        };
    }
    function NestedFormEntity(specs) {
        return function (target, propertyKey) {
            InputsMetaData.add(Object.assign(Object.assign({}, specs), { inputType: exports.InputTypes.COMPOSITE }), target, propertyKey);
        };
    }
    function CustomInput(specs) {
        return function (target, propertyKey) {
            InputsMetaData.add(Object.assign(Object.assign({}, specs), { inputType: specs.inputType.toUpperCase() }), target, propertyKey);
        };
    }
    // TODO make it replacement for custominput and name it dynamic form input
    // todo rename dynmic form input to dynamic form input component or form input component
    // mark the other as depricated
    // export function DynamicInput<S extends InputSpec>(specs: S){
    //   return function (target: any, propertyKey: string) {
    //     InputsMetaData.add(
    //       { ...specs, inputType: specs.inputType.toUpperCase() },
    //       target,
    //       propertyKey
    //     );
    //   };
    // }

    function Reset(meta) {
        return function (constructor) {
            ActionsMetaData.add(Object.assign(Object.assign({}, meta), { type: 'reset' }), constructor);
            return /** @class */ (function (_super) {
                __extends(class_1, _super);
                function class_1() {
                    return _super !== null && _super.apply(this, arguments) || this;
                }
                return class_1;
            }(constructor));
        };
    }

    function Submit(meta) {
        return function (constructor) {
            ActionsMetaData.add(Object.assign(Object.assign({}, meta), { type: 'submit' }), constructor);
            return /** @class */ (function (_super) {
                __extends(class_1, _super);
                function class_1() {
                    return _super !== null && _super.apply(this, arguments) || this;
                }
                return class_1;
            }(constructor));
        };
    }

    function Button(meta) {
        return function (constructor) {
            ActionsMetaData.add(Object.assign(Object.assign({}, meta), { type: 'button' }), constructor);
            return /** @class */ (function (_super) {
                __extends(class_1, _super);
                function class_1() {
                    return _super !== null && _super.apply(this, arguments) || this;
                }
                return class_1;
            }(constructor));
        };
    }

    function Required(errConfig) {
        return function (target, propertyKey) {
            ValidationsMetaData.add({
                errorName: 'required',
                errorMessage: errConfig.message,
                validatorFn: i2.Validators.required,
            }, target, propertyKey);
        };
    }

    function RequiredTrue(errConfig) {
        return function (target, propertyKey) {
            ValidationsMetaData.add({
                errorName: 'required',
                errorMessage: errConfig.message,
                validatorFn: i2.Validators.requiredTrue,
            }, target, propertyKey);
        };
    }

    function Max(errConfig) {
        return function (target, propertyKey) {
            ValidationsMetaData.add({
                errorName: 'max',
                errorMessage: errConfig.message,
                validatorFn: i2.Validators.max(errConfig.maxValue),
            }, target, propertyKey);
        };
    }

    function Min(errConfig) {
        return function (target, propertyKey) {
            ValidationsMetaData.add({
                errorName: 'min',
                errorMessage: errConfig.message,
                validatorFn: i2.Validators.min(errConfig.minValue),
            }, target, propertyKey);
        };
    }

    function MaxLength(errConfig) {
        return function (target, propertyKey) {
            ValidationsMetaData.add({
                errorName: 'maxlength',
                errorMessage: errConfig.message,
                validatorFn: i2.Validators.maxLength(errConfig.maxlength),
            }, target, propertyKey);
        };
    }

    function MinLength(errConfig) {
        return function (target, propertyKey) {
            ValidationsMetaData.add({
                errorName: 'minlength',
                errorMessage: errConfig.message,
                validatorFn: i2.Validators.minLength(errConfig.minlength),
            }, target, propertyKey);
        };
    }

    function Pattern(errConfig) {
        return function (target, propertyKey) {
            ValidationsMetaData.add({
                errorName: 'pattern',
                errorMessage: errConfig.message,
                validatorFn: i2.Validators.pattern(errConfig.pattern),
            }, target, propertyKey);
        };
    }

    function Email(errConfig) {
        return function (target, propertyKey) {
            ValidationsMetaData.add({
                errorName: 'email',
                errorMessage: errConfig.message,
                validatorFn: i2.Validators.email,
            }, target, propertyKey);
        };
    }

    function MaxDate(errConfig) {
        return function (target, propertyKey) {
            ValidationsMetaData.add({
                errorName: 'maxDate',
                errorMessage: errConfig.message,
                validatorFn: DateValidation.max(errConfig.maxDate),
            }, target, propertyKey);
        };
    }
    function MinDate(errConfig) {
        return function (target, propertyKey) {
            ValidationsMetaData.add({
                errorName: 'minDate',
                errorMessage: errConfig.message,
                validatorFn: DateValidation.min(errConfig.minDate),
            }, target, propertyKey);
        };
    }
    var DateValidation = /** @class */ (function () {
        function DateValidation() {
        }
        DateValidation.max = function (value) {
            var max = DateValidation.parseDate(value);
            return function (control) {
                var dateVal = DateValidation.parseDate(control.value);
                if (dateVal <= max)
                    return null;
                else
                    return { maxDate: true };
            };
        };
        DateValidation.min = function (value) {
            var min = DateValidation.parseDate(value);
            return function (control) {
                var dateVal = DateValidation.parseDate(control.value);
                if (dateVal >= min)
                    return null;
                else
                    return { minDate: true };
            };
        };
        DateValidation.parseDate = function (date) {
            if (date == null || (typeof date == 'string' && !isNaN(Date.parse(date)))) {
                // empty strings gives invalid date so if empty string
                // is passed as argument its converted to zero date since epoch
                return new Date(date == '' ? 0 : date);
            }
            else if (date instanceof Date)
                return date;
            else
                throw new Error('invalid date format ' + date);
        };
        return DateValidation;
    }());

    function CrossValidation(spec) {
        // return (target) => {
        //   const crossValidationMeta = Reflect.getMetadata(
        //     CROSS_VALIDATION_METADATA_KEY,
        //     target
        //   );
        //   if (!crossValidationMeta) {
        //     return Reflect.defineMetadata(
        //       CROSS_VALIDATION_METADATA_KEY,
        //       [spec],
        //       target
        //     );
        //   } else {
        //     crossValidationMeta.push(spec);
        //   }
        // };
        return function (constructor) {
            CrossValidationMeta.add(spec, constructor);
            return /** @class */ (function (_super) {
                __extends(class_1, _super);
                function class_1() {
                    return _super !== null && _super.apply(this, arguments) || this;
                }
                return class_1;
            }(constructor));
        };
    }

    function AsyncValidation(specs) {
        return function (target, propertyKey) {
            AsyncValidationMeta.add(specs, target, propertyKey);
        };
    }

    /*
     * Public API Surface of decorator-driven-dynamic-form
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AsyncValidation = AsyncValidation;
    exports.Button = Button;
    exports.ButtonTemplateDirective = ButtonTemplateDirective;
    exports.CheckboxInput = CheckboxInput;
    exports.ContextOverride = ContextOverride;
    exports.CrossValidation = CrossValidation;
    exports.CustomInput = CustomInput;
    exports.DateInput = DateInput;
    exports.DateValidation = DateValidation;
    exports.DynamicFormComponent = DynamicFormComponent;
    exports.DynamicFormContextService = DynamicFormContextService;
    exports.DynamicFormInput = DynamicFormInput;
    exports.DynamicFormModule = DynamicFormModule;
    exports.Email = Email;
    exports.ErrorMessagePipe = ErrorMessagePipe;
    exports.FormEntity = FormEntity;
    exports.FormEntityProcessorService = FormEntityProcessorService;
    exports.ID_META_KEY = ID_META_KEY;
    exports.Id = Id;
    exports.InputComponent = InputComponent;
    exports.InputTemplateDirective = InputTemplateDirective;
    exports.Max = Max;
    exports.MaxDate = MaxDate;
    exports.MaxLength = MaxLength;
    exports.Min = Min;
    exports.MinDate = MinDate;
    exports.MinLength = MinLength;
    exports.NestedFormEntity = NestedFormEntity;
    exports.NumberInput = NumberInput;
    exports.ON_CONTEXT_META_KEY = ON_CONTEXT_META_KEY;
    exports.Pattern = Pattern;
    exports.RadioGroupInput = RadioGroupInput;
    exports.Required = Required;
    exports.RequiredTrue = RequiredTrue;
    exports.Reset = Reset;
    exports.SelectInput = SelectInput;
    exports.Submit = Submit;
    exports.TextInput = TextInput;
    exports.USE_CONTEXT_META_KEY = USE_CONTEXT_META_KEY;
    exports.UseContext = UseContext;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ddd-form.umd.js.map
