import { TextInputSpec, NumberInputSpec, DateInputSpec, SelectInputSpec, CheckInputSpec, RadioButtonsSpec, CustomInputSpec } from '../../types/inputs/input-specs';
import { NestedFormSpec } from '../../types/forms/form-meta';
export declare function TextInput(specs: TextInputSpec): (target: any, propertyKey: string) => void;
export declare function NumberInput(specs: NumberInputSpec): (target: any, propertyKey: string) => void;
export declare function DateInput(specs: DateInputSpec): (target: any, propertyKey: string) => void;
export declare function SelectInput(specs: SelectInputSpec): (target: any, propertyKey: string) => void;
export declare function CheckboxInput(specs: CheckInputSpec): (target: any, propertyKey: string) => void;
export declare function RadioGroupInput(specs: RadioButtonsSpec): (target: any, propertyKey: string) => void;
export declare function NestedFormEntity(specs: NestedFormSpec): (target: any, propertyKey: string) => void;
export declare function CustomInput(specs: CustomInputSpec): (target: any, propertyKey: string) => void;
