import { ValidatorFn } from '@angular/forms';
export declare function MaxDate(errConfig: {
    message: string;
    maxDate: string | Date;
}): (target: any, propertyKey: string) => void;
export declare function MinDate(errConfig: {
    message: string;
    minDate: string | Date;
}): (target: any, propertyKey: string) => void;
export declare class DateValidation {
    static max(value: string | Date): ValidatorFn;
    static min(value: string | Date): ValidatorFn;
    private static parseDate;
}
