import { AbstractControl } from '@angular/forms';
import { InputNode } from './input-node';
export declare class InputNodeImpl implements InputNode {
    private properties;
    private control;
    private errorMap;
    private childNodes;
    /**
     *
     */
    constructor(properties: Map<string, any>, control: AbstractControl, errorMap: Map<string, string>);
    setProperties(map: Map<string, any>): void;
    addProperty(key: string, value: any): void;
    getProperty(key: string): any;
    setControl(control: AbstractControl): void;
    getControl(): AbstractControl;
    setErrorMap(map: Map<string, string>): void;
    getError(key: string): string | undefined;
    addError(key: string, value: string): void;
    addChild(node: InputNodeImpl): void;
    addChildren(nodes: InputNodeImpl[]): void;
    getChildren(): InputNodeImpl[] | null;
    hasChildren(): boolean;
    isValid(): boolean;
    inValid(): boolean;
    isPending(): boolean;
}
