import { ValidatorFn } from '@angular/forms';
import 'reflect-metadata';
declare type Effect = {
    input: string;
    message: string;
};
export declare type CrossValidationSpec = {
    errorName: string;
    effects: Effect[];
    validatorFn: ValidatorFn;
};
export declare function CrossValidation(spec: CrossValidationSpec): <T extends new (...args: any[]) => {}>(constructor: T) => {
    new (...args: any[]): {};
} & T;
export {};
