import { ValidatorFn } from '@angular/forms';
import { ValidationSpec } from './validations';
export declare const VALIDATION_METADATA_KEY: unique symbol;
export declare class ValidationsMetaData {
    static add(validationSpec: ValidationSpec, target: any, propertyKey: string): void;
    static get(target: any, propertyKey: string): ValidationSpec[] | undefined;
    static getValidatorsAndErrorMap(target: any, propertyKey: string): {
        validators: ValidatorFn[];
        errorMap: Map<string, string>;
    };
}
