import { BasicActionMeta } from '../actions/actions';
import { UpdateStrategy } from './form-update-strategy';
export declare type FormSpec = {
    name: string;
    updateStrategy?: UpdateStrategy;
};
export declare type NestedFormSpec = {
    legend?: string;
    name: string;
    declaredClass: any;
    class?: string;
    legendClass?: string;
    width?: number;
};
export declare class FormMeta {
    name: string;
    actions: BasicActionMeta[];
    updateStrategy: UpdateStrategy;
    constructor(formSpec: FormSpec);
}
