import { ModuleWithProviders, Type } from '@angular/core';
import * as i0 from "@angular/core";
import * as i1 from "./ui/components/dynamic-form/dynamic-form.component";
import * as i2 from "./ui/pipes/error-message.pipe";
import * as i3 from "./ui/components/input/input.component";
import * as i4 from "./ui/directives/input-template/input-template.directive";
import * as i5 from "./ui/components/input-resolver/input-resolver.component";
import * as i6 from "./ui/directives/input-anchor/input-anchor.directive";
import * as i7 from "./ui/components/default-inputs/text-input/text-input.component";
import * as i8 from "./ui/components/default-inputs/number-input/number-input.component";
import * as i9 from "./ui/components/default-inputs/date-input/date-input.component";
import * as i10 from "./ui/components/default-inputs/checkbox-input/checkbox-input.component";
import * as i11 from "./ui/components/default-inputs/nested-form/nested-form.component";
import * as i12 from "./ui/components/default-inputs/radio-buttons-input/radio-buttons-input.component";
import * as i13 from "./ui/components/default-inputs/select-input/select-input.component";
import * as i14 from "./ui/directives/button-template/button-template.directive";
import * as i15 from "@angular/common";
import * as i16 from "@angular/forms";
export declare class DynamicFormModule {
    private static defaultInputComponents;
    static register(entities: Type<any>[]): ModuleWithProviders<DynamicFormModule>;
    static ɵfac: i0.ɵɵFactoryDeclaration<DynamicFormModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DynamicFormModule, [typeof i1.DynamicFormComponent, typeof i2.ErrorMessagePipe, typeof i3.InputComponent, typeof i4.InputTemplateDirective, typeof i5.InputResolverComponent, typeof i6.InputAnchorDirective, typeof i7.TextInputComponent, typeof i8.NumberInputComponent, typeof i9.DateInputComponent, typeof i10.CheckboxInputComponent, typeof i11.NestedFormComponent, typeof i12.RadioButtonsInputComponent, typeof i13.SelectInputComponent, typeof i14.ButtonTemplateDirective], [typeof i15.CommonModule, typeof i16.FormsModule, typeof i16.ReactiveFormsModule], [typeof i1.DynamicFormComponent, typeof i4.InputTemplateDirective, typeof i3.InputComponent, typeof i14.ButtonTemplateDirective, typeof i2.ErrorMessagePipe]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DynamicFormModule>;
}
