import { OnInit, TemplateRef, ComponentFactoryResolver, OnChanges, SimpleChanges } from '@angular/core';
import { InputNode } from '../../../core/models/types/inputs/input-node';
import { InputAnchorDirective } from '../../directives/input-anchor/input-anchor.directive';
import { InputComponent } from '../input/input.component';
import * as i0 from "@angular/core";
export declare class InputResolverComponent implements OnInit, OnChanges {
    private resolver;
    inputNode: InputNode;
    inputTemplatesMap: Map<string, TemplateRef<any>>;
    inputAnchor: InputAnchorDirective;
    private inputComponentsRegistry;
    constructor(resolver: ComponentFactoryResolver);
    ngOnChanges(changes: SimpleChanges): void;
    ngOnInit(): void;
    getInputNode(): InputNode;
    getTemplateRef(): TemplateRef<any> | null;
    getInputComponent(): import("@angular/core").Type<InputComponent> | undefined;
    renderInputComponent(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<InputResolverComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<InputResolverComponent, "[df-input-resolver]", never, { "inputNode": "inputNode"; "inputTemplatesMap": "inputTemplatesMap"; }, {}, never, never>;
}
